=== modified file 'lib/canonical/launchpad/subscribers/karma.py'
--- lib/canonical/launchpad/subscribers/karma.py	2011-12-09 22:03:04 +0000
+++ lib/canonical/launchpad/subscribers/karma.py	2011-12-09 22:10:24 +0000
@@ -7,7 +7,6 @@
 from canonical.database.sqlbase import block_implicit_flushes
 from lp.bugs.interfaces.bugtask import BugTaskStatus
 from lp.bugs.subscribers.bug import get_bug_delta
-from lp.code.enums import BranchMergeProposalStatus
 from lp.registry.interfaces.person import IPerson
 
 
@@ -121,62 +120,7 @@
 
 
 @block_implicit_flushes
-def branch_created(branch, event):
-    """Assign karma to the user who registered the branch."""
-    branch.target.assignKarma(branch.registrant, 'branchcreated')
-
-
-@block_implicit_flushes
 def bug_branch_created(bug_branch, event):
     """Assign karma to the user who linked the bug to the branch."""
     bug_branch.branch.target.assignKarma(
         bug_branch.registrant, 'bugbranchcreated')
-
-
-@block_implicit_flushes
-def branch_merge_proposed(proposal, event):
-    """Assign karma to the user who proposed the merge."""
-    proposal.source_branch.target.assignKarma(
-        proposal.registrant, 'branchmergeproposed')
-
-
-@block_implicit_flushes
-def code_review_comment_added(code_review_comment, event):
-    """Assign karma to the user who commented on the review."""
-    proposal = code_review_comment.branch_merge_proposal
-    target = proposal.source_branch.target
-    # If the user is commenting on their own proposal, then they don't
-    # count as a reviewer for that proposal.
-    user = code_review_comment.message.owner
-    reviewer = user.inTeam(proposal.target_branch.code_reviewer)
-    if reviewer and user != proposal.registrant:
-        target.assignKarma(user, 'codereviewreviewercomment')
-    else:
-        target.assignKarma(user, 'codereviewcomment')
-
-
-@block_implicit_flushes
-def branch_merge_status_changed(proposal, event):
-    """Assign karma to the user who approved the merge."""
-    target = proposal.source_branch.target
-    user = IPerson(event.user)
-
-    in_progress_states = (
-        BranchMergeProposalStatus.WORK_IN_PROGRESS,
-        BranchMergeProposalStatus.NEEDS_REVIEW)
-
-    if ((event.to_state == BranchMergeProposalStatus.CODE_APPROVED) and
-        (event.from_state in (in_progress_states))):
-        if user == proposal.registrant:
-            target.assignKarma(user, 'branchmergeapprovedown')
-        else:
-            target.assignKarma(user, 'branchmergeapproved')
-    elif ((event.to_state == BranchMergeProposalStatus.REJECTED) and
-          (event.from_state in (in_progress_states))):
-        if user == proposal.registrant:
-            target.assignKarma(user, 'branchmergerejectedown')
-        else:
-            target.assignKarma(user, 'branchmergerejected')
-    else:
-        # Only care about approved and rejected right now.
-        pass

=== modified file 'lib/lp/blueprints/subscribers.py'
--- lib/lp/blueprints/subscribers.py	2011-12-09 22:03:04 +0000
+++ lib/lp/blueprints/subscribers.py	2011-12-09 22:10:24 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2010 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type

=== modified file 'lib/lp/code/configure.zcml'
--- lib/lp/code/configure.zcml	2011-11-28 03:51:37 +0000
+++ lib/lp/code/configure.zcml	2011-12-09 22:10:24 +0000
@@ -377,11 +377,11 @@
   <subscriber
       for="lp.code.interfaces.branchmergeproposal.IBranchMergeProposal
            lp.code.interfaces.event.INewBranchMergeProposalEvent"
-      handler="canonical.launchpad.subscribers.karma.branch_merge_proposed"/>
+      handler="lp.code.subscribers.karma.branch_merge_proposed"/>
   <subscriber
       for="lp.code.interfaces.branchmergeproposal.IBranchMergeProposal
            lp.code.interfaces.event.IBranchMergeProposalStatusChangeEvent"
-      handler="canonical.launchpad.subscribers.karma.branch_merge_status_changed"/>
+      handler="lp.code.subscribers.karma.branch_merge_status_changed"/>
   <adapter
       for="lp.code.interfaces.branchmergeproposal.IBranchMergeProposal"
       provides="canonical.launchpad.webapp.interfaces.IPrimaryContext"
@@ -494,7 +494,7 @@
   <subscriber
       for="lp.code.interfaces.branch.IBranch
            lazr.lifecycle.interfaces.IObjectCreatedEvent"
-      handler="canonical.launchpad.subscribers.karma.branch_created"/>
+      handler="lp.code.subscribers.karma.branch_created"/>
   <subscriber
       for="lp.codehosting.scanner.events.ITipChanged"
       handler="lp.codehosting.scanner.email.queue_tip_changed_email_jobs"/>
@@ -644,7 +644,7 @@
   <subscriber
       for="lp.code.interfaces.codereviewcomment.ICodeReviewComment
            lp.code.interfaces.event.INewCodeReviewCommentEvent"
-      handler="canonical.launchpad.subscribers.karma.code_review_comment_added"/>
+      handler="lp.bugs.subscribers.karma.code_review_comment_added"/>
   <adapter
       for="lp.code.interfaces.codereviewcomment.ICodeReviewComment"
       provides="canonical.launchpad.webapp.interfaces.IPrimaryContext"

=== added file 'lib/lp/code/subscribers/karma.py'
--- lib/lp/code/subscribers/karma.py	1970-01-01 00:00:00 +0000
+++ lib/lp/code/subscribers/karma.py	2011-12-09 22:10:24 +0000
@@ -0,0 +1,63 @@
+# Copyright 2011 Canonical Ltd.  This software is licensed under the
+# GNU Affero General Public License version 3 (see the file LICENSE).
+
+"""Assign karma for code domain activity."""
+
+from canonical.database.sqlbase import block_implicit_flushes
+from lp.code.enums import BranchMergeProposalStatus
+from lp.registry.interfaces.person import IPerson
+
+
+@block_implicit_flushes
+def branch_created(branch, event):
+    """Assign karma to the user who registered the branch."""
+    branch.target.assignKarma(branch.registrant, 'branchcreated')
+
+
+@block_implicit_flushes
+def branch_merge_proposed(proposal, event):
+    """Assign karma to the user who proposed the merge."""
+    proposal.source_branch.target.assignKarma(
+        proposal.registrant, 'branchmergeproposed')
+
+
+@block_implicit_flushes
+def code_review_comment_added(code_review_comment, event):
+    """Assign karma to the user who commented on the review."""
+    proposal = code_review_comment.branch_merge_proposal
+    target = proposal.source_branch.target
+    # If the user is commenting on their own proposal, then they don't
+    # count as a reviewer for that proposal.
+    user = code_review_comment.message.owner
+    reviewer = user.inTeam(proposal.target_branch.code_reviewer)
+    if reviewer and user != proposal.registrant:
+        target.assignKarma(user, 'codereviewreviewercomment')
+    else:
+        target.assignKarma(user, 'codereviewcomment')
+
+
+@block_implicit_flushes
+def branch_merge_status_changed(proposal, event):
+    """Assign karma to the user who approved the merge."""
+    target = proposal.source_branch.target
+    user = IPerson(event.user)
+
+    in_progress_states = (
+        BranchMergeProposalStatus.WORK_IN_PROGRESS,
+        BranchMergeProposalStatus.NEEDS_REVIEW)
+
+    if ((event.to_state == BranchMergeProposalStatus.CODE_APPROVED) and
+        (event.from_state in (in_progress_states))):
+        if user == proposal.registrant:
+            target.assignKarma(user, 'branchmergeapprovedown')
+        else:
+            target.assignKarma(user, 'branchmergeapproved')
+    elif ((event.to_state == BranchMergeProposalStatus.REJECTED) and
+          (event.from_state in (in_progress_states))):
+        if user == proposal.registrant:
+            target.assignKarma(user, 'branchmergerejectedown')
+        else:
+            target.assignKarma(user, 'branchmergerejected')
+    else:
+        # Only care about approved and rejected right now.
+        pass

